<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        <v-btn @click="doAdd">Add New</v-btn>
      </v-col>
      <v-col cols="7">
        <h1>User</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="users"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="doEdit(item.username)" v-if="$store.getters.getRoles.length === 0 && $store.getters.isDefaultUser === true && item.default_user === true">mdi-pencil</v-icon>
            <v-icon small class="mr-2" @click="doEdit(item.username)" v-else-if="$store.getters.getRoles.includes('SUPER_ADMIN_WEB')">mdi-pencil</v-icon>
            <v-icon small class="mr-2" @click="doEdit(item.username)" v-else-if="$store.getters.getRoles.includes('ADMIN_WEB') && !item.roles.includes('SUPER_ADMIN_WEB') && !item.default_user">mdi-pencil</v-icon>

            <v-card-text small class="mr-2" v-if="item.username === $store.getters.getUsername">(Current)</v-card-text>

            <v-icon small class="mr-2" @click="doResetPassword(item.username)" v-if="item.username !== $store.getters.getUsername && $store.getters.getRoles.length === 0 && $store.getters.isDefaultUser === true && item.default_user === true">mdi-lock</v-icon>
            <v-icon small class="mr-2" @click="doResetPassword(item.username)" v-else-if="item.username !== $store.getters.getUsername && $store.getters.getRoles.includes('SUPER_ADMIN_WEB')">mdi-lock</v-icon>
            <v-icon small class="mr-2" @click="doResetPassword(item.username)" v-else-if="item.username !== $store.getters.getUsername && $store.getters.getRoles.includes('ADMIN_WEB') && !item.roles.includes('SUPER_ADMIN_WEB') && !item.default_user">mdi-lock</v-icon>

            <v-icon small class="mr-2" @click="doDelete(item)" v-if="item.username !== $store.getters.getUsername && $store.getters.getRoles.length === 0 && $store.getters.isDefaultUser === true && item.default_user === true">
              mdi-delete
            </v-icon>
            <v-icon small class="mr-2" @click="doDelete(item)" v-else-if="item.username !== $store.getters.getUsername && $store.getters.getRoles.includes('SUPER_ADMIN_WEB')">
              mdi-delete
            </v-icon>
            <v-icon small class="mr-2" @click="doDelete(item)" v-else-if="item.username !== $store.getters.getUsername && $store.getters.getRoles.includes('ADMIN_WEB') && !item.roles.includes('SUPER_ADMIN_WEB') && !item.default_user">
              mdi-delete
            </v-icon>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <UserForm ref="dlg" />
    <UserResetForm ref="dlgReset" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import UserForm from "../components/UserForm";
import UserResetForm from "../components/UserResetPassword";

import service from "../service/UserService";
import dateFormat from "dateformat"

export default {
  name: "User",
  components: {
    UserResetForm,
    UserForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      users: [],
      title: null,
      headers: [
        { text: "ACTION", align: "center", value: "actions", sortable: false },
        { text: "FULL NAME", align: "left", value: "full_name", sortable: true },
        { text: "USERNAME", align: "center", value: "username", sortable: true },
        { text: "EMAIL", align: "center", value: "email", sortable: true },
        { text: "TELEGRAM ID", align: "center", value: "telegram_id", sortable: true },
        { text: "Active", align: "center", value: "enabled", sortable: true },
        { text: "EXPIRED DATE", align: "center", value: "expired_date", sortable: true },
        { text: "EXPIRED PASSWORD DATE", align: "center", value: "expired_password_date", sortable: true },
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    doAdd() {
      let title = "Add New User"
      this.$refs.dlg.doAdd(title, false)
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Menghapus Data USER ${data.username}`)) {
        return false;
      }
      this.statusProgress = true
      await service.delete(data.username).then(async res => {
        let {status, message} = res.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        console.log(ex)
        this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
      })
      this.statusProgress = false
    },
    doEdit(id) {
      let title = "Edit User"
      let isEdit2 = id === this.$store.getters.getUsername && !this.$store.getters.isDefaultUser && this.$store.getters.getRoles.includes('SUPER_ADMIN_WEB')
      this.$refs.dlg.doEdit(id, title, true, isEdit2)
    },
    doResetPassword(username) {
      let title = "Reset Password User"
      this.$refs.dlgReset.doEdit(username, title, false)
    },
    async doRefresh() {
      this.statusProgress = true
      await service.getAll()
          .then(res => {
            let status = res.data.status
            if (status === 'SUCCESS') {
              this.users = []
              let users = res.data.data
              for (let user of users) {
                user.full_name = `${user.first_name} ${user.last_name !== null ? user.last_name : ''}`
                user.enabled = user.enabled ? 'Yes' : 'No'
                user.expired_date = dateFormat(user.expired_date, 'dddd, dd mmmm yyyy')
                user.expired_password_date = dateFormat(user.expired_password_date, 'dddd, dd mmmm  yyyy')
                user.roles = []
                for (let resource_access of user.resource_accesses) {
                  for (let role of resource_access.roles) {
                    user.roles.push(`${role.name}_${resource_access.client_id.toUpperCase()}`)
                  }
                }
                this.users.push(user)
              }
            }
          })
      this.statusProgress = false
    }
  },
  mounted() {
    this.doRefresh()
  }
}
</script>

<style scoped>

</style>